Index: /palm/trunk/SCRIPTS/NCL/cross_sections.ncl
===================================================================
--- /palm/trunk/SCRIPTS/NCL/cross_sections.ncl	(revision 161)
+++ /palm/trunk/SCRIPTS/NCL/cross_sections.ncl	(revision 162)
@@ -395,141 +492,692 @@
    ; ****************************************************
 
-   do varn=dim-1,0,1  
-
-      if ( vNam(varn) .eq. "zw" .or. vNam(varn) .eq. "yv" .or. vNam(varn) .eq. "xu" .or. vNam(varn) .eq. "zu" .or. vNam(varn) .eq. "zwwi" .or. vNam(varn) .eq. "zusi" .or. vNam(varn) .eq. "time" .or. vNam(varn) .eq. "zu_3d" .or. vNam(varn) .eq. "zw_3d" .or. vNam(varn) .eq. "x" .or. vNam(varn) .eq. "y" .or. vNam(varn) .eq. "zu_xy" .or. vNam(varn) .eq. "zw_xy" .or. vNam(varn) .eq. "zu1_xy" .or. vNam(varn) .eq. "ind_z_xy" .or. vNam(varn) .eq. "y_xz" .or. vNam(varn) .eq. "yv_xz" .or. vNam(varn) .eq. "ind_y_xz" .or. vNam(varn) .eq. "x_yz" .or. vNam(varn) .eq. "xu_yz" .or. vNam(varn) .eq. "ind_x_yz") then
-         check = False
+   if (xyc .EQ. 1) then
+      do varn=0,dim-1
+         if (vNam(varn) .eq. "xu"  .OR. vNam(varn) .eq. "x")then    
+            x_d     = f->$vNam(varn)$
+            xdim    = dimsizes(x_d)-1
+            delta_x = x_d(1)-x_d(0)
+            break
+         end if
+      end do 
+      do varn=0,dim-1
+         if (vNam(varn) .eq. "yv" .or. vNam(varn) .eq. "y")then   
+            y_d     = f->$vNam(varn)$
+            ydim    = dimsizes(y_d)-1
+            delta_y = y_d(1)-y_d(0)
+            break
+         end if
+      end do
+      do varn=0,dim-1
+         if (vNam(varn) .eq. "zu_3d" .OR. vNam(varn) .eq. "zw_3d")then
+            z_d     = f->$vNam(varn)$
+            zdim    = dimsizes(z_d)-1
+            delta_z = 0
+            break
+         else
+            if (vNam(varn) .eq. "zu_xy" .OR. vNam(varn) .eq. "zw_xy") then
+               z_d     = f->$vNam(varn)$
+               zdim    = dimsizes(z_d)-1 
+               delta_z = -1.d
+               break
+            else
+               zdim    = 0
+               delta_z = -1.d
+            end if
+         end if
+      end do
+   end if
+   if (xzc .EQ. 1) then
+      do varn=0,dim-1
+         if (vNam(varn) .eq. "xu"  .OR. vNam(varn) .eq. "x") then 
+            x_d     = f->$vNam(varn)$
+            xdim    = dimsizes(x_d)-1
+            delta_x = x_d(1)-x_d(0)
+            break
+         end if
+      end do
+      do varn=0,dim-1   
+         if (vNam(varn) .eq. "zw" .or. vNam(varn) .eq. "zu" .OR. vNam(varn) .eq. "zu_3d" .or. vNam(varn) .eq. "zw_3d") then
+            z_d     = f->$vNam(varn)$
+            zdim    = dimsizes(z_d)-1 
+            delta_z = z_d(1)-z_d(0)
+            break
+         end if
+      end do
+      do varn=0,dim-1 
+         if (vNam(varn) .eq. "yv" .or. vNam(varn) .eq. "y") then
+            y_d     = f->$vNam(varn)$
+            ydim    = dimsizes(y_d)-1
+            delta_y = y_d(1)-y_d(0)
+            break
+         else
+            if (vNam(varn) .eq. "y_xz" .or. vNam(varn) .eq. "yv_xz") then
+               y_d     = f->$vNam(varn)$
+               ydim    = dimsizes(y_d)-1 
+               delta_y = -1.d
+               break
+            else
+               ydim    = 0
+               delta_y = -1.d
+            end if
+         end if 
+      end do
+   end if
+   if (yzc .EQ. 1) then
+      do varn=0,dim-1  
+         if (vNam(varn) .eq. "yv" .or. vNam(varn) .eq. "y") then
+            y_d     = f->$vNam(varn)$
+            ydim    = dimsizes(y_d)-1
+            delta_y = y_d(1)-y_d(0)
+            break
+         end if
+      end do
+      do varn=0,dim-1 
+         if (vNam(varn) .eq. "zw" .or. vNam(varn) .eq. "zu" .OR. vNam(varn) .eq. "zu_3d" .or. vNam(varn) .eq. "zw_3d") then
+            z_d     = f->$vNam(varn)$
+            zdim    = dimsizes(z_d)-1 
+            delta_z = z_d(1)-z_d(0)
+            break
+         end if
+      end do
+      do varn=0,dim-1 
+         if (vNam(varn) .eq. "xu" .or. vNam(varn) .eq. "x")
+            x_d     = f->$vNam(varn)$
+            xdim    = dimsizes(x_d)-1 
+            delta_x = x_d(1)-x_d(0)
+            break
+         else
+            if (vNam(varn) .eq. "xu_yz" .or. vNam(varn) .eq. "x_yz" ) then
+               x_d     = f->$vNam(varn)$
+               xdim    = dimsizes(x_d)-1 
+               delta_x = -1.d
+               break
+            else
+               xdim    = 0
+               delta_x = -1.d
+            end if
+         end if 
+      end do
+   end if
+   
+   ; ****************************************************
+   ; set up ranges of x-, y- and z-coordinates
+   ; ****************************************************         
+                    
+   if ( .not. isvar("xs") ) then     		
+      xs     = 0.0d
+      xstart = 0
+      if (parameter(63) .NE. "x0") then
+         if (delta_x .EQ. -1) then
+            print(" ") 
+            print("You cannot choose a start value for x, there are preseted layers for x")
+            print(" ")
+            xstart=0
+         else
+            if (stringtodouble(parameter(63)) .LT. 0-delta_x/2) then
+               print(" ")
+               print("range start for x-coordinate = "+parameter(63)+"m is lower than first value x = "+0+"m or xu = "+(0-delta_x/2)+"m")
+               print(" ")
+               exit
+            end if
+            if (xyc .EQ. 1 .OR. xzc .EQ. 1) then
+               if (stringtodouble(parameter(63)) .GE. xdim*delta_x) then
+                  print(" ")
+                  print("range start for x-coordinate = "+parameter(63)+"m is equal or greater than last value = "+xdim*delta_x+"m")
+                  print(" ")
+                  exit
+               end if 
+            else
+               if (stringtodouble(parameter(63)) .GT. xdim*delta_x) then
+                  print(" ")
+                  print("range start for x-coordinate = "+parameter(63)+"m is greater than last value = "+xdim*delta_x+"m")
+                  print(" ")
+                  exit
+               end if 
+            end if
+            xs = stringtodouble(parameter(63))
+         end if
+      end if
+   else
+      if (delta_x .EQ. -1) then
+         print(" ") 
+         print("You cannot choose a start value for x, there are preseted layers for x")
+         print(" ")
+         xstart=0
       else
-         check = True
-      end if    
-      if (  isvar("var") ) then  
-         check = isStrSubset( var,","+vNam(varn)+",")
-      end if
-      if (parameter(21) .NE. "variables") then
-         var = parameter(21) 
-         check = isStrSubset( var,","+vNam(varn)+"," ) 
-      end if   
-
-      if(check) then
-         print(vNam(varn))
-         data_all = f->$vNam(varn)$
-
-         ; ****************************************************
-         ; set up ranges of x-, y- and z-coordinates
-         ; ****************************************************         
-                    
-         xdim = dimsizes(data_all(0,0,0,:)) - 1    
-         ydim = dimsizes(data_all(0,0,:,0)) - 1        
-         zdim = dimsizes(data_all(0,:,0,0)) - 1  
-       
-         if ( .not. isvar("xe")) then     ; output x-coordinate range end (in index)
-            xe = xdim
-            if (parameter(53) .NE. "xdim") then
-               if (stringtointeger(parameter(53)) .GT. xdim) then
-                  print(" ")
-                  print("range end for x-coordinate = "+parameter(53)+" is higher than available dimensions = "+xdim)
-                  print(" ") 
+         if (xs .LT. 0-delta_x/2) then
+            print(" ")
+            print("range start for x-coordinate = "+xs+"m is lower than first value = "+(0-delta_x/2)+"m")
+            print(" ")
+            exit
+         end if
+         if (xyc .EQ. 1 .OR. xzc .EQ. 1) then
+            if (xs .GE. xdim*delta_x) then
+               print(" ")
+               print("range start for x-coordinate = "+xs+"m is equal or greater than last value = "+xdim*delta_x+"m")
+               print(" ")
+               exit
+            end if 
+         else
+            if (xs .GT. xdim*delta_x) then
+               print(" ")
+               print("range start for x-coordinate = "+xs+"m is greater than last value = "+xdim*delta_x+"m")
+               print(" ")
+               exit
+            end if 
+         end if
+      end if
+   end if 
+
+   if ( .not. isvar("ys") ) then    
+      ys = 0.0d
+      ystart = 0
+      if (parameter(67) .NE. "y0") then
+         if (delta_y .EQ. -1) then
+            print(" ") 
+            print("You cannot choose a start value for y, there are preseted layers for y")
+            print(" ")
+            ystart=0
+         else
+            if (stringtodouble(parameter(67)) .LT. 0-delta_y/2) then
+               print(" ")
+               print("range start for y-coordinate = "+parameter(67)+"m is lower than first value = "+0-delta_y/2+"m")
+               print(" ")
+               exit
+            end if
+            if (xyc .EQ. 1 .OR. yzc .EQ. 1) then
+               if (stringtodouble(parameter(67)) .GE. ydim*delta_y) then
+                  print(" ")
+                  print("range start for y-coordinate = "+parameter(67)+"m is equal or greater than last value = "+ydim*delta_y+"m")
+                  print(" ")
                   exit
                end if
-               if (stringtointeger(parameter(53)) .LT. 0 .OR. stringtointeger(parameter(53)) .LT. xs) then
-                  print(" ")
-                  print("range end for x-coordinate = "+parameter(53)+" is too small")
+            else
+               if (stringtodouble(parameter(67)) .GT. ydim*delta_y) then
+                  print(" ")
+                  print("range start for y-coordinate = "+parameter(67)+"m is greater than last value = "+ydim*delta_y+"m")
                   print(" ")
                   exit
                end if
-               xe = stringtointeger(parameter(53)) 
-            end if 
-         else
-            if (xe .GT. xdim) then
-               print(" ")
-               print("range end for x-coordinate = "+xe+" is higher than available dimensions = "+xdim)
-               print(" ")
-               exit
-            end if
-            if (xe .LT. 0 .OR. xe .LT. xs) then
-               print(" ")
-               print("range end for x-coordinate = "+xe+" is too small")
-               print(" ")
-               exit
-            end if                  
-         end if
-
-         if ( .not. isvar("ye")) then     ; output y-coordinate range end (in index)
-            ye = ydim
-            if (parameter(57) .NE. "ydim") then
-               if (stringtointeger(parameter(57)) .GT. ydim) then
-                  print(" ")
-                  print("range end for y-coordinate = "+parameter(57)+" is higher than available dimensions = "+ydim)
+            end if
+            ys = stringtodouble(parameter(67))
+         end if
+      end if
+   else
+      if (delta_y .EQ. -1) then
+         print(" ") 
+         print("You cannot choose a start value for y, there are preseted layers for y")
+         print(" ")
+         ystart=0
+      else
+         if (ys .LT. 0-delta_y/2) then
+            print(" ")
+            print("range start for y-coordinate = "+ys+"m is lower than first value = "+0-delta_y/2+"m")
+            print(" ")
+            exit
+         end if
+         if (xyc .EQ. 1 .OR. yzc .EQ. 1) then
+            if (ys .GE. ydim*delta_y) then
+               print(" ")
+               print("range start for y-coordinate = "+ys+"m is equal or greater than last value = "+ydim*delta_y+"m")
+               print(" ")
+               exit
+            end if
+         else
+            if (ys .GT. ydim*delta_y) then
+               print(" ")
+               print("range start for y-coordinate = "+ys+"m is greater than last value = "+ydim*delta_y+"m")
+               print(" ")
+               exit
+            end if
+         end if
+      end if
+   end if
+  
+   if ( .not. isvar("zs") ) then     			; start of z-coordinate range
+      zs = 0
+      if (parameter(71) .NE. "z0") then
+         if (delta_z .EQ. -1) then
+            print(" ") 
+            print("You cannot choose a start value for z, there are preseted layers for z")
+            print(" ")
+         else
+            print(" ")
+            print("Please mind to indicate start and end ranges for the z-coordinate in")
+            print("indices not in 'meters'. Corresponding index and meter:")
+            print(" ")
+            print(" = "+z_d+" m")
+            print(" ") 
+            if (stringtointeger(parameter(71)) .LT. 0) then
+               print(" ")
+               print("range start for z-coordinate = "+parameter(71)+" is lower than first gridpoint = 0")
+               print(" ")
+               exit
+            end if
+            if (xzc .EQ. 1 .OR. yzc .EQ. 1) then
+               if (stringtointeger(parameter(71)) .GE. zdim) then
+                  print(" ")
+                  print("range start for z-coordinate = "+parameter(71)+" is equal or greater than last gridpoint = "+zdim)
                   print(" ")
                   exit
                end if
-               if (stringtointeger(parameter(57)) .LT. 0 .OR. stringtointeger(parameter(57)) .LT. ys) then
-                  print(" ")
-                  print("range end for y-coordinate = "+parameter(57)+" is too small")
+            else
+               if (stringtodouble(parameter(71)) .GT. zdim) then
+                  print(" ")
+                  print("range start for z-coordinate = "+parameter(71)+" is greater than last gridpoint = "+zdim)
                   print(" ")
                   exit
                end if
-               ye = stringtointeger(parameter(57)) 
+            end if
+            zs = stringtointeger(parameter(71))
+         end if
+      end if
+   else
+      if (delta_z .EQ. -1) then
+         print(" ") 
+         print("You cannot choose a start value for z, there are preseted layers for z")
+         print(" ")
+      else
+         if (zs .LT. 0) then
+            print(" ")
+            print("range start for z-coordinate = "+zs+" is lower than first gridpoint = 0")
+            print(" ")
+            exit
+         end if
+         if (xzc .EQ. 1 .OR. yzc .EQ. 1) then
+            if (zs .GE. zdim) then
+               print(" ")
+               print("range start for z-coordinate = "+zs+" is equal or greater than last gridpoint = "+zdim)
+               print(" ")
+               exit
+            end if
+         else
+            if (zs .GT. zdim) then
+               print(" ")
+               print("range start for z-coordinate = "+zs+" is greater than last gridpoint = "+zdim)
+               print(" ")
+               exit
+            end if
+         end if
+      end if
+   end if  
+
+   if ( .not. isvar("xe")) then    
+      xe   = xdim*delta_x
+      xend = xdim
+      if (parameter(65) .NE. "xdim") then
+         if (delta_x .EQ. -1) then
+            print(" ") 
+            print("You cannot choose an end value for x, there are preseted layers for x")
+            print(" ") 
+            xend=xdim           
+         else
+            if (stringtodouble(parameter(65)) .GT. xdim*delta_x) then
+               print(" ")
+               print("range end for x-coordinate = "+parameter(65)+"m is greater than last value = "+xdim*delta_x+"m")
+               print(" ") 
+               exit 
             end if 
-         else
-            if (ye .GT. ydim) then
-               print(" ")
-               print("range end for y-coordinate = "+ye+" is higher than available dimensions = "+ydim)
-               print(" ")
-               exit 
-            end if
-            if (ye .LT. 0 .OR. ye .LT. ys) then
-               print(" ")
-               print("range end for y-coordinate = "+ye+" is too small")
-               print(" ")
-               exit
-            end if
-         end if
-
-         if ( .not. isvar("ze")) then     ; output z-coordinate range end (in index)
-            ze = zdim
-            if (parameter(61) .NE. "zdim") then
-               if (stringtointeger(parameter(61)) .GT. zdim) then
-                  print(" ")
-                  print("range end for z-coordinate = "+parameter(61)+" is higher than available dimensions = "+zdim)
+            if (xyc .EQ. 1 .OR. xzc .EQ. 1) then
+               if (stringtodouble(parameter(65)) .LE. 0-delta_x/2)
+                  print(" ")
+                  print("range end for x-coordinate = "+parameter(65)+"m is equal or lower than first value = "+(0-delta_x/2)+"m")
                   print(" ")
                   exit
                end if
-               if (stringtointeger(parameter(61)) .LT. 0 .OR. stringtointeger(parameter(61)) .LT. zs) then
-                  print(" ")
-                  print("range end for z-coordinate = "+parameter(61)+" is too small")
+               if (stringtodouble(parameter(65)) .LE. xs) then
+                  print(" ")
+                  print("range end for x-coordinate = "+parameter(65)+"m is equal or lower than start range = "+xs+"m")
                   print(" ")
                   exit
                end if
-               ze = stringtointeger(parameter(61)) 
+            else
+               if (stringtodouble(parameter(65)) .LT. 0-delta_x/2)
+                  print(" ")
+                  print("range end for x-coordinate = "+parameter(65)+"m is lower than first value = "+(0-delta_x/2)+"m")
+                  print(" ")
+                  exit
+               end if
+               if (stringtodouble(parameter(65)) .LT. xs) then
+                  print(" ")
+                  print("range end for x-coordinate = "+parameter(65)+"m is lower than start range = "+xs+"m")
+                  print(" ")
+                  exit
+               end if
+            end if         
+            xe = stringtodouble(parameter(65)) 
+         end if 
+      end if
+   else
+      if (delta_x .EQ. -1) then
+         print(" ") 
+         print("You cannot choose an end value for x, there are preseted layers for x")
+         print(" ")
+         xend=xdim
+      else
+         if (xe .GT. xdim*delta_x) then
+            print(" ")
+            print("range end for x-coordinate = "+xe+"m is greater than last value = "+xdim*delta_x+"m")
+            print(" ") 
+            exit 
+         end if 
+         if (xyc .EQ. 1 .OR. xzc .EQ. 1) then
+            if (xe .LE. 0-delta_x/2)
+               print(" ")
+               print("range end for x-coordinate = "+xe+"m is equal or lower than first value = "+(0-delta_x/2)+"m")
+               print(" ")
+               exit
+            end if
+            if (xe .LE. xs) then
+               print(" ")
+               print("range end for x-coordinate = "+xe+"m is equal or lower than start range = "+xs+"m")
+               print(" ")
+               exit
+            end if
+            if (stringtodouble(xe .EQ. xs+1)) then
+               print(" ")
+               print("range end for x-coordinate = "+xe+"m must be at least two more gridpoints greater than start range = "+xs+"m")
+               print(" ")
+               exit
+            end if
+         else
+            if (xe .LT. 0-delta_x/2)
+               print(" ")
+               print("range end for x-coordinate = "+xe+"m is lower than first value = "+(0-delta_x/2)+"m")
+               print(" ")
+               exit
+            end if
+            if (xe .LT. xs) then
+               print(" ")
+               print("range end for x-coordinate = "+xe+"m is lower than start range = "+xs+"m")
+               print(" ")
+               exit
+            end if
+         end if 
+      end if               
+   end if
+
+   if ( .not. isvar("ye")) then  
+      ye   = ydim*delta_y
+      yend = ydim
+      if (parameter(69) .NE. "ydim") then
+         if (delta_y .EQ. -1) then
+            print(" ") 
+            print("You cannot choose an end value for y, there are preseted layers for y")
+            print(" ")
+            yend=ydim
+         else
+            if (stringtodouble(parameter(69)) .GT. ydim*delta_y) then
+               print(" ")
+               print("range end for y-coordinate = "+parameter(69)+"m is greater than last value = "+ydim*delta_y+"m")
+               print(" ") 
+               exit 
             end if 
-         else
-            if (ze .GT. zdim) then
-               print(" ")
-               print("range end for z-coordinate = "+ze+" is higher than available dimensions = "+zdim)
+            if (xyc .EQ. 1 .OR. yzc .EQ. 1) then
+               if (stringtodouble(parameter(69)) .LE. 0-delta_y/2)
+                  print(" ")
+                  print("range end for y-coordinate = "+parameter(69)+"m is equal or lower than first value = "+(0-delta_y/2)+"m")
+                  print(" ")
+                  exit
+               end if
+               if (stringtodouble(parameter(69)) .LE. ys) then
+                  print(" ")
+                  print("range end for y-coordinate = "+parameter(69)+"m is equal or lower than start range = "+ys+"m")
+                  print(" ")
+                  exit
+               end if
+               if (stringtodouble(parameter(69)) .EQ. ys+1) then
+                  print(" ")
+                  print("range end for y-coordinate = "+parameter(69)+"m must be at least two more gridpoints greater than start range = "+ys+"m")
+                  print(" ")
+                  exit
+               end if 
+            else
+               if (stringtodouble(parameter(69)) .LT. 0-delta_y/2)
+                  print(" ")
+                  print("range end for y-coordinate = "+parameter(69)+"m is lower than first value = "+(0-delta_y/2)+"m")
+                  print(" ")
+                  exit
+               end if
+               if (stringtodouble(parameter(69)) .LT. ys) then
+                  print(" ")
+                  print("range end for y-coordinate = "+parameter(69)+"m is lower than start range = "+ys+"m")
+                  print(" ")
+                  exit
+               end if
+            end if         
+            ye = stringtodouble(parameter(69)) 
+         end if 
+      end if
+   else
+      if (delta_y .EQ. -1) then
+         print(" ") 
+         print("You cannot choose an end value for y, there are preseted layers for y")
+         print(" ")
+         yend=ydim
+      else
+         if (ye .GT. ydim*delta_y) then
+            print(" ")
+            print("range end for y-coordinate = "+ye+"m is greater than last value = "+ydim*delta_y+"m")
+            print(" ") 
+            exit 
+         end if 
+         if (xyc .EQ. 1 .OR. yzc .EQ. 1) then
+            if (ye .LE. 0-delta_y/2)
+               print(" ")
+               print("range end for y-coordinate = "+ye+"m is equal or lower than first value = "+(0-delta_y/2)+"m")
+               print(" ")
+               exit
+            end if
+            if (ye .LE. ys) then
+               print(" ")
+               print("range end for y-coordinate = "+ye+"m is equal or lower than start range = "+ys+"m")
+               print(" ")
+               exit
+            end if
+            if (ye .EQ. ys+1) then
+               print(" ")
+               print("range end for y-coordinate = "+ye+"m must be at least two more gridpoints greater than start range = "+ys+"m")
+               print(" ")
+               exit
+            end if
+         else
+            if (ye .LT. 0-delta_y/2)
+               print(" ")
+               print("range end for y-coordinate = "+ye+"m is lower than first value = "+(0-delta_y/2)+"m")
+               print(" ")
+               exit
+            end if
+            if (ye .LT. ys) then
+               print(" ")
+               print("range end for y-coordinate = "+ye+"m is lower than start range = "+ys+"m")
+               print(" ")
+               exit
+            end if
+         end if
+      end if
+   end if 
+ 
+   if ( .not. isvar("ze")) then  
+      ze = zdim
+      if (parameter(73) .NE. "zdim") then
+         if (delta_z .EQ. -1) then
+            print(" ") 
+            print("You cannot choose an end value for z, there are preseted layers for z")
+            print(" ")           
+         else
+            if (stringtointeger(parameter(73)) .GT. zdim) then
+               print(" ")
+               print("range end for z-coordinate = "+parameter(73)+" is greater than last gridpoint = "+zdim)
                print(" ") 
-               exit
-            end if
-            if (ze .LT. 0 .OR. ze .LT. zs) then
-               print(" ")
-               print("range end for z-coordinate = "+ze+" is too small")
-               print(" ")
-               exit
-            end if
-         end if   
-         delete(data_all)
-      end if  
-   end do
-
+               exit 
+            end if 
+         if (xzc .EQ. 1 .OR. yzc .EQ. 1) then
+            if (stringtointeger(parameter(73)) .LE. 0)
+               print(" ")
+               print("range end for z-coordinate = "+parameter(73)+" is equal or lower than first gridpoint = 0")
+               print(" ")
+               exit
+            end if
+            if (stringtointeger(parameter(73)) .LE. zs) then
+               print(" ")
+               print("range end for z-coordinate = "+parameter(73)+" is equal or lower than start range = "+zs)
+               print(" ")
+               exit
+            end if
+            if (stringtodouble(parameter(73)) .EQ. zs+1) then
+               print(" ")
+               print("range end for z-coordinate = "+parameter(73)+" must be at least two more gridpoints greater than start range = "+zs)
+               print(" ")
+               exit
+            end if
+         else
+            if (stringtointeger(parameter(73)) .LT. 0)
+               print(" ")
+               print("range end for z-coordinate = "+parameter(73)+" is lower than first gridpoint = 0")
+               print(" ")
+               exit
+            end if
+            if (stringtointeger(parameter(73)) .LT. zs) then
+               print(" ")
+               print("range end for z-coordinate = "+parameter(73)+" is lower than start range = "+zs)
+               print(" ")
+               exit
+            end if
+         end if         
+         ze = stringtointeger(parameter(73)) 
+      end if 
+      end if
+   else
+      if (delta_z .EQ. -1) then
+         print(" ") 
+         print("You cannot choose an end value for z, there are preseted layers for z")
+         print(" ")
+         ze = zdim
+      else
+         if (ze .GT. zdim) then
+            print(" ")
+            print("range end for z-coordinate = "+ze+" is greater than last gridpoint = "+zdim)
+            print(" ") 
+            exit 
+         end if 
+         if (xzc .EQ. 1 .OR. yzc .EQ. 1) then
+            if (ze .LE. 0)
+               print(" ")
+               print("range end for z-coordinate = "+ze+" is equal or lower than first gridpoint = 0")
+               print(" ")
+               exit
+            end if
+            if (ze .LE. zs) then
+               print(" ")
+               print("range end for z-coordinate = "+ze+" is equal or lower than start range = "+zs)
+               print(" ")
+               exit
+            end if
+            if (ze .EQ. zs+1) then
+               print(" ")
+               print("range end for z-coordinate = "+ze+" must be at least two more gridpoints greater than start range = "+zs)
+               print(" ")
+               exit
+            end if
+         else
+            if (ze .LT. 0)
+               print(" ")
+               print("range end for z-coordinate = "+ze+" is lower than first gridpoint = 0")
+               print(" ")
+               exit
+            end if
+            if (ze .LT. zs) then
+               print(" ")
+               print("range end for z-coordinate = "+ze+" is lower than start range = "+zs)
+               print(" ")
+               exit
+            end if
+         end if
+      end if
+   end if 
+
+   if (delta_x .NE. -1) then
+      do i=0,xdim    
+         if (xs .GT. x_d(i)-delta_x/2 .AND. xs .LE. x_d(i)+delta_x/2)then
+            xstart=i
+            break
+         end if
+      end do 
+      do i=0,xdim    
+         if (xe .GT. x_d(i)-delta_x/2 .AND. xe .LE. x_d(i)+delta_x/2)then
+            xend=i
+            break
+         end if
+      end do
+   end if
+   if (delta_y .NE. -1) then
+      do i=0,xdim    
+         if (ys .GT. y_d(i)-delta_y/2 .AND. ys .LE. y_d(i)+delta_y/2)then
+            ystart=i
+            break
+         end if
+      end do 
+      do i=0,xdim    
+         if (ye .GT. y_d(i)-delta_y/2 .AND. ye .LE. y_d(i)+delta_y/2)then
+            yend=i
+            break
+         end if
+      end do 
+   end if
+   
+   delete(xs)
+   delete(xe)   
+   delete(ys)
+   delete(ye)
+
+   xs=xstart
+   xe=xend
+   ys=ystart
+   ye=yend
+
+   if (xyc .EQ. 1 .OR. xzc .EQ.1)then
+      if (xe .EQ. xs+1) then
+         print(" ")
+         print("range end for x-coordinate="+parameter(65)+"m(=>value on file="+xe*delta_x+"m) must be at least two") 
+         print("more gridpoints(="+2*delta_x+"m) greater than start range="+parameter(63)+"m(=>value on file="+xs*delta_x+"m)")
+         print(" ")
+         exit
+      end if 
+   end if
+   if (xyc .EQ. 1 .OR. yzc .EQ.1)then
+      if (ye .EQ. ys+1) then
+         print(" ")
+         print("range end for y-coordinate="+parameter(69)+"m(=>value on file="+ye*delta_y+"m) must be at least two") 
+         print("more gridpoints(="+2*delta_y+"m) greater than start range="+parameter(67)+"m(=>value on file="+ys*delta_y+"m)")
+         print(" ")
+         exit
+      end if 
+   end if
+   if (xzc .EQ. 1 .OR. yzc .EQ.1)then
+      if (ze .EQ. zs+1) then
+         print(" ")
+         print("range end for x-coordinate="+parameter(73)+"(=> value on file="+ze+") must be at least two") 
+         print("more gridpoints greater than start range="+parameter(71)+"(=>value on file="+zs+")")
+         print(" ")
+         exit
+      end if 
+   end if
+  
    if (xyc .EQ. 1) then
       no_layer = (ze-zs)+1
+      data = new((/dim,nt,zdim+1,(ye-ys)+1,(xe-xs)+1/),float)
    end if
    if (xzc .EQ. 1) then
       no_layer = (ye-ys)+1
+      data = new((/dim,nt,(ze-zs)+1,ydim+1,(xe-xs)+1/),float)
    end if
    if (yzc .EQ. 1) then
       no_layer = (xe-xs)+1
-   end if
-
-   data  = new((/dim,nt,(ze-zs)+1,(ye-ys)+1,(xe-xs)+1/),float)
+      data = new((/dim,nt,(ze-zs)+1,(ye-ys)+1,xdim+1/),float)
+   end if
+
+   MinVal = new(dim,float)
+   MaxVal = new(dim,float) 
 
    ; ****************************************************
@@ -571,5 +1219,5 @@
       
       data_all = f->$vNam(varn)$ 
-
+    
       if (vector .EQ. 1) then    
          check_vec1 = isStrSubset( vec1,","+vNam(varn)+",")
@@ -590,5 +1238,5 @@
       end if  
 
-      if(check) then 
+      if(check) then
 
          no_var=no_var+1
@@ -603,5 +1251,14 @@
          end if 
 
-         data(varn,:,:,:,:)=data_all(0:nt-1,zs:ze,ys:ye,xs:xe) 
+         if (xyc .EQ. 1) then
+            data(varn,:,:,:,:)=data_all(:,:,ys:ye,xs:xe) 
+         end if
+         if ( xzc .eq. 1 ) then
+            data(varn,:,:,:,:)=data_all(:,zs:ze,:,xs:xe) 
+         end if
+         if ( yzc .eq. 1) then
+            data(varn,:,:,:,:)=data_all(:,zs:ze,ys:ye,:) 
+         end if
+
          if (check_vec1) then
             vect1=data_all
@@ -615,5 +1272,8 @@
    	 data!2 = "z"
    	 data!3 = "y"
-   	 data!4 = "x"   
+   	 data!4 = "x"  
+
+         MinVal(varn) = min(data(varn,:,:,:,:))
+         MaxVal(varn) = max(data(varn,:,:,:,:))
 
       end if
